nx_server_plugin_sdk 1.0 Server Plugin SDK

Public Member Functions | Friends | List of all members
nx_spl::FtpStorageFactory Class Reference
Inheritance diagram for nx_spl::FtpStorageFactory:

## Public Member Functions
virtual const char **STORAGE_METHOD_CALL | findAvailable () const override
virtual Storage *STORAGE_METHOD_CALL | createStorage (const char *url, int *ecode) override
virtual const char *STORAGE_METHOD_CALL | storageType () const override
virtual const char * | lastErrorMessage (int ecode) const override
virtual void * | queryInterface (const nxpl::NX_GUID &interfaceID) override
| Cast to type, specified by interfaceID. More...
virtual int | addRef () const override
| Increment reference counter. More...
virtual int | releaseRef () const override
| Decrement reference counter. More...

## Friends
class | aux::PluginRefCounter< FtpStorageFactory >

## Member Function Documentation

## ◆ addRef()

int nx_spl::FtpStorageFactory::addRef | ( |  | ) | const
| override virtual

Increment reference counter.

Returns
  new reference count

Note
  PluginInterface::releaseRef is not guaranteed to be called from thread that called PluginInterface::addRef

Implements nxpl::PluginInterface.

## ◆ createStorage()

Storage * nx_spl::FtpStorageFactory::createStorage | ( | const char * | url,
|  | int * | ecode
| ) |  |
| override virtual

Parameters

  url | Storage root URL. This should be NULL terminated utf8 encoded C string.
  ecode | Pointer to error code. Pass NULL if you are not interested in error information.

Returns
  pointer to Storage.

Implements nx_spl::StorageFactory.

## ◆ findAvailable()

const char ** nx_spl::FtpStorageFactory::findAvailable | ( |  | ) | const
| override virtual

Returns
  available utf8 encoded urls list. Iterate till NULL.

Implements nx_spl::StorageFactory.

## ◆ lastErrorMessage()

const char * nx_spl::FtpStorageFactory::lastErrorMessage | ( | int | ecode | ) | const
| override virtual

Parameters

  ecode | Error code

Returns
  NULL terminated utf8 encoded C string

Implements nx_spl::StorageFactory.

## ◆ queryInterface()

void * nx_spl::FtpStorageFactory::queryInterface | ( | const nxpl::NX_GUID & | interfaceID | ) |
| override virtual

Cast to type, specified by interfaceID.

If pointer cannot be cast, NULL MUST be returned

Returns
  If not NULL, returned pointer can be safely cast to type, defined by interfaceID

Note
  This method increments reference counter

Implements nxpl::PluginInterface.

## ◆ releaseRef()

int nx_spl::FtpStorageFactory::releaseRef | ( |  | ) | const
| override virtual

Decrement reference counter.

When zero, object MUST be removed

Returns
  new reference count

Note
  PluginInterface::releaseRef is not guaranteed to be called from thread that called PluginInterface::addRef

Implements nxpl::PluginInterface.

## ◆ storageType()

const char *STORAGE_METHOD_CALL nx_spl::FtpStorageFactory::storageType | ( |  | ) | const
| override virtual

Returns
  English name of the Storage type. This name can be shown to the user, but is not used programmatically, so it can be any human-readable name, like "local", "network", "smb", "ftp", "tape", etc.

Implements nx_spl::StorageFactory.

The documentation for this class was generated from the following files:

- samples/storage/ftp_storage_plugin/src/ftp_library.h
- samples/storage/ftp_storage_plugin/src/ftp_library.cpp